# -*- coding: utf-8 -*-
"""CNN_Keras_MNIST_Code3.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1AyfCPnGp63caWflOeUoPddASNzZT21EW
"""

from __future__ import print_function
import keras
from keras.models import Sequential
from keras.layers import Dense, Dropout, Flatten,Activation
from keras.layers import Conv2D, MaxPooling2D
from keras.layers import Input,add
import numpy as np
import tensorflow as tf

# Import MNIST data
from tensorflow.examples.tutorials.mnist import input_data
mnist = input_data.read_data_sets("MNIST_data/", one_hot=True)

# Parameters
learning_rate = 0.001 #learning rate or step size for optimization
batch_size = 100 # batch size to input the in batches

# Network Parameters
n_input = 784 # MNIST data input (img shape: 28*28)
n_classes = 10 # MNIST total classes (0-9 digits)
dropout = 0.8 # Dropout, probability to keep units

# (3) Create a sequential model
#model = Sequential()

# 1st Convolutional Layer (here you should also define the input shape)

# model.add(Conv2D(filters=32, input_shape=(28,28,1), kernel_size=(5,5),strides=(1,1),activation='relu', padding='same'))
# 1st Pooling Layer
inputs=Input(shape=(28,28,1))
conv1=Conv2D(filters=32,  kernel_size=(5,5),strides=(1,1),activation='relu', padding='same')(inputs)
conv2=Conv2D(filters=32,  kernel_size=(5,5),strides=(1,1),activation='relu', padding='same')(conv1)
conv3=Conv2D(filters=32,  kernel_size=(5,5),strides=(1,1),activation='relu', padding='same')(conv2)
conv4=Conv2D(filters=16, kernel_size=(5,5), strides=(1,1), padding='same',activation='relu')(conv3)
# TODO: add a project shortcut connection between conv1 and conv4 by using Conv2D with kernel size (1,1)
shortcut=Conv2D(filters=16,  kernel_size=(1,1),strides=(1,1))(conv1)
res = add([shortcut,conv4])# TODO: add shortcut and conv4. This is the output of our residual block
# Passing it to a dense layer
flat=Flatten()(res)
# 1st Dense Layer
dense=Dense(1024,activation='relu')(flat)
# Add Dropout to prevent overfitting
dr=Dropout(dropout)(dense)
# Output Layer
out=Dense(n_classes,activation='softmax')(dr)
model = keras.models.Model(inputs=[inputs], outputs=[out])
model.summary()
model.compile(loss=keras.losses.categorical_crossentropy,
              optimizer=keras.optimizers.Adam(lr=learning_rate),
              metrics=['accuracy'])

X0 = mnist.train.images
X = np.reshape(X0, (55000, 28, 28, 1))
Y  = mnist.train.labels

Xv0 = mnist.validation.images
Xv  = np.reshape(Xv0, (5000, 28, 28, 1))
Yv  = mnist.validation.labels
model.fit(X, Y, batch_size=batch_size,epochs=1,verbose=1,validation_data=(Xv, Yv))#steps_per_epoch= 550,validation_steps =  2

Xt0 = mnist.test.images
Xt0.shape
XT  = np.reshape(Xt0, (10000, 28, 28, 1))
YT  = mnist.test.labels
# Evaluation
score = model.evaluate (x=XT, y=YT, batch_size=batch_size, verbose =0)
print('Test loss:', score[0], 'and Test accuracy:', score[1])
